/*
 * Copyright (C) 2010-2011 Dmitry Marakasov
 *
 * This file is part of glosm.
 *
 * glosm is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glosm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glosm.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LAYER_HH
#define LAYER_HH

#include "Math.hh"

class Viewer;

/**
 * Abstact base class for all layers.
 *
 * Layer is a renderable representation of a single kind of geodata.
 */
class Layer {
public:
	virtual ~Layer() {
	}

	virtual void RequestVisible(const BBoxi& bbox) = 0;
	virtual void Render(const Viewer& viewer) const = 0;
};

#endif
